% localization of local stiffness matrix into global matrix - 2D trinagular element with linear approximation functions
% In:
%   k  - stiffness matrix of the structure
%   ke - stiffness matrix of one element
%   lm - vector of nodal code numbers of one element
%   e  - element number
%
% Out:
%   k - stiffness matrix of the structure
%
function k = assembly (k,ke,lm,e)

ndof = size(ke,1);
for i=1:ndof
        ia = lm(e,i);
        if ia ~=0
            for j=1:ndof
                ja=lm(e,j);
                if ja ~=0
                  k(ia,ja)=k(ia,ja)+ke(i,j);
                end
            end
        end
    end
end
